import { StreamieQueueError } from './error';
import { Streamie, Handler, Config, BatchedIfConfigured, IfFilteredElse } from './types';
export default function streamie<IQT extends any, OQT extends IfFilteredElse<BatchedIfConfigured<IQT, C>, any, C>, const C extends Config>(handler: Handler<IQT, OQT, C>, config: C & {
    seed?: IQT;
}): {
    push: (...items: IQT[]) => void;
    map: <NOQT extends IfFilteredElse<BatchedIfConfigured<OQT, NC>, any, NC>, NC extends Config>(handler: Handler<OQT, NOQT, NC>, config: NC) => Streamie<OQT, NOQT, NC>;
    filter: <NC_1 extends Omit<Config, "isFilter">>(handler: Handler<OQT, boolean, NC_1>, config: NC_1) => Streamie<OQT, BatchedIfConfigured<OQT, NC_1>, NC_1>;
    pause: (shouldPause?: boolean) => void;
    drain: () => void;
    registerInput: (inputStreamie: Streamie<any, IQT, any>) => void;
    registerOutput: (outputStreamie: Streamie<OQT, any, any>) => void;
    state: {
        readonly backpressure: {
            input: boolean;
            output: boolean;
        };
        readonly count: {
            started: number;
            handling: number;
            queued: {
                readonly input: number;
                readonly output: number;
            };
        };
        readonly isPaused: boolean;
        readonly isDrained: boolean;
        readonly isHalted: boolean;
    };
    onBackpressureRelease: (eventHandler: () => void) => void;
    onDrained: (eventHandler: () => void) => void;
    onDraining: (eventHandler: () => void) => void;
    onError: (eventHandler: (error: StreamieQueueError<IQT, C>) => void) => void;
    onHalted: (eventHandler: () => void) => void;
    _pushQueueError: (error: StreamieQueueError<any, any>) => void;
    promise: Promise<null>;
};
